#ifndef _ASM_X86_MMU_H
#define _ASM_X86_MMU_H

#include <linux/spinlock.h>
#include <linux/mutex.h>

/*
 * The x86 doesn't have a mmu context, but
 * we put the segment information here.
 */
typedef struct {
#ifndef __GENKSYMS__
	struct ldt_struct *ldt;
#else
	void *ldt;
#endif
	int size;               /* Unused, KABI compatibility */

#ifdef CONFIG_X86_64
	/* True if mm supports a task running in 32 bit compatibility mode. */
	unsigned short ia32_compat;
#endif

	struct mutex lock;
	void *vdso;
} mm_context_t;

void leave_mm(int cpu);

#endif /* _ASM_X86_MMU_H */
